## smlsharp 1.2.0

=== benchmark/benchmarks/Makefile ===
SMLSHARP = ../../src/compiler/smlsharp -B ../../src
DOIT_SUFFIX =
LIBS =

all: \
    barnes_hut/doit$(DOIT_SUFFIX) \
    boyer/doit$(DOIT_SUFFIX) \
    coresml/doit$(DOIT_SUFFIX) \
    count_graphs/doit$(DOIT_SUFFIX) \
    cpstak/doit$(DOIT_SUFFIX) \
    diviter/doit$(DOIT_SUFFIX) \
    divrec/doit$(DOIT_SUFFIX) \
    fft/doit$(DOIT_SUFFIX) \
    gcbench/doit$(DOIT_SUFFIX) \
    knuth_bendix/doit$(DOIT_SUFFIX) \
    lexgen/doit$(DOIT_SUFFIX) \
    life/doit$(DOIT_SUFFIX) \
    logic/doit$(DOIT_SUFFIX) \
    mandelbrot/doit$(DOIT_SUFFIX) \
    mlyacc/doit$(DOIT_SUFFIX) \
    nucleic/doit$(DOIT_SUFFIX) \
    perm9/doit$(DOIT_SUFFIX) \
    puzzle/doit$(DOIT_SUFFIX) \
    ratio_regions/doit$(DOIT_SUFFIX) \
    ray/doit$(DOIT_SUFFIX) \
    simple/doit$(DOIT_SUFFIX) \
    tsp/doit$(DOIT_SUFFIX) \
    vliw/doit$(DOIT_SUFFIX)

.SUFFIXES: .o .smi .sml

.sml.o:
	$(SMLSHARP) -c -o $@ $<

include link.mk
include depend.mk

=== sample/callback/Makefile ===
SMLSHARP = smlsharp

callback: callback.smi callback.o callback_c.o
	$(SMLSHARP) -o $@ callback.smi callback_c.o
callback.o: callback.sml
	$(SMLSHARP) -c -o $@ callback.sml
callback_c.o: callback.c
	$(CC) $(CFLAGS) -c -o $@ callback.c

clean:
	-rm -f callback callback.o callback_c.o

=== sample/glut/Makefile ===
SMLSHARP = smlsharp
LIBS = -Wl,-framework,OpenGL -Wl,-framework,GLUT  # for Mac OS X
#LIBS = -L/usr/X11R6/lib -lgl -lglu -lglut

cube: cube.smi cube.o libglut.o
	$(SMLSHARP) -o $@ cube.smi $(LIBS)
cube.o: cube.sml cube.smi libglut.smi
	$(SMLSHARP) -c -o $@ cube.sml
libglut.o: libglut.sml libglut.smi
	$(SMLSHARP) -c -o $@ libglut.sml

clean:
	-rm -f cube cube.o libglut.o

=== sample/pthread_sieve/Makefile ===
SMLSHARP = smlsharp

pthread_sieve: load.smi pthread.o mvar.o sieve.o load.o
	$(SMLSHARP) -o $@ load.smi $(LIBS)

pthread.o: pthread.sml pthread.smi
	$(SMLSHARP) -c -o $@ pthread.sml
mvar.o: mvar.sml mvar.smi pthread.smi
	$(SMLSHARP) -c -o $@ mvar.sml
sieve.o: sieve.sml sieve.smi mvar.smi pthread.smi
	$(SMLSHARP) -c -o $@ sieve.sml
load.o: load.sml load.smi sieve.smi mvar.smi pthread.smi
	$(SMLSHARP) -c -o $@ load.sml

clean:
	-rm -f pthread_sieve pthread.o mvar.o sieve.o load.o

## smlsharp 1.1.0

=== debian/changelog ===
smlsharp (1.1.0-1) unstable; urgency=low

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 09 Aug 2012 05:52:40 +0900

smlsharp (1.0.3-1) unstable; urgency=low

  * Initial release (Closes: #682823)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 24 Jul 2012 15:28:44 +0900

=== debian/control ===
Source: smlsharp
Section: devel
Priority: extra
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), gcc-multilib, ed, mawk,
	lib32gmp-dev [amd64], libgmp-dev [i386]
Standards-Version: 3.9.3
Homepage: http://www.pllab.riec.tohoku.ac.jp/smlsharp/
Vcs-Git: git://anonscm.debian.org/collab-maint/smlsharp.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/smlsharp.git

Package: smlsharp
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Standard ML compiler with practical extensions
 SML# is a variant of Standard ML programming
 language with several practical extentions,
 including seamless interoperability with C,
 integration with SQL, and separate compilation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	CC="gcc -m32" LD="ld -m elf_i386"	\
		CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		./configure --prefix=/usr --enable-fast-build	\
		--enable-thread

## smlsharp 1.2.0

=== debian/changelog ===
smlsharp (1.2.0-2) unstable; urgency=low

  * Update debian/control.
    - Set Architecture to i386 only. (Closes: #718108)
    - Bump Standards-Version to 3.9.4.
    - Add libgmp-dev to Depends.
  * Add README.Debian.
    Add infomation about support architecture.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 29 Jul 2013 11:26:41 +0900

smlsharp (1.2.0-1) unstable; urgency=low

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 21 Nov 2012 12:24:30 +0900

=== debian/control ===
Source: smlsharp
Section: devel
Priority: extra
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), gcc-multilib, ed, mawk,
	libgmp-dev, cpio
Standards-Version: 3.9.4
Homepage: http://www.pllab.riec.tohoku.ac.jp/smlsharp/
Vcs-Git: git://anonscm.debian.org/collab-maint/smlsharp.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/smlsharp.git

Package: smlsharp
Architecture: i386
Depends: ${shlibs:Depends}, ${misc:Depends}, libgmp-dev
Description: Standard ML compiler with practical extensions
 SML# is a variant of Standard ML programming
 language with several practical extentions,
 including seamless interoperability with C,
 integration with SQL, and separate compilation.

=== debian/rules ===
--- 
+++ 
@@ -15,3 +15,9 @@
 		CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
 		./configure --prefix=/usr --enable-fast-build	\
 		--enable-thread
+
+override_dh_auto_clean:
+	dh_auto_clean
+
+	rm -rf precompiled/fastbuild1
+	rm -rf precompiled/fastbuild2

## smlsharp 4.0.0

=== debian/changelog ===
smlsharp (4.0.0-3) unstable; urgency=medium

  * Upload to unstable.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 30 Sep 2021 14:01:20 +0900

smlsharp (4.0.0-2) experimental; urgency=medium

  * Update d/control
    - Drop i386 from Architecture. This is not support.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 30 Sep 2021 08:28:41 +0900

smlsharp (4.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Update d/control
    - Add "Rules-Requires-Root: no".
    - Update Vcs-Git and Vcs-Browser field.
    - Update Homepage field.
    - Change Priority from extra to optional.
    - Add llvm-dev and libmassivethreads-dev to B-D.
    - Drop gcc-multilib, ed, mawk and cpio from B-D.
    - Set Architecture to i386 and amd64.
  * Add d/upstream/metadata
  * Update d/copyright
    - Update source field.
    - Get rid of lintian 'insecure-copyright-format-uri'.
  * Remove d/source.lintian-overrides.
  * Update d/rules
    - Remove override_dh_auto_clean target.
  * Add d/watch.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 23 Sep 2021 17:17:37 +0900

smlsharp (3.6.0-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Update d/control.
    * Update debhelper dependency to "Build-Depends: debhelper-compat (= 13)".
    * Drop dpkg-dev from B-D.
    * Bump Standards-Version to 4.5.1 (no change).
  * Add d/gbp.conf

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sun, 27 Dec 2020 14:42:54 +0900

## smlsharp 4.0.0+git20211227.5af5945b

=== benchmark/benchmarks_parallel/Makefile ===
CC = gcc -pthread
CFLAGS = -Wall -W -O2
CPPFLAGS = -I_thread -Imassivethreads/include
LDFLAGS = -Lmassivethreads/lib
SMLSHARP = ../../src/compiler/smlsharp -B../../src
SMLFLAGS = -O2
GHC = ~/work/ghc-8.10.2/o/bin/ghc
GHCFLAGS = -O2
GO = ~/work/go/bin/go
JAVAC = javac
PMLC = ~/work/manticore/o/bin/pmlc
MPL = ~/work/mpl/build/bin/mpl
OCAMLFIND = ocamlfind

all: \
fib/fib_c_myth \
fib/fib_c_pthread \
fib/fib_c_seq \
fib/fib_smlsharp_myth \
fib/fib_smlsharp_pthread \
fib/fib_smlsharp_seq \
fib/fib_ghc_par \
fib/fib_go_value \
fib/FibJavaForkJoin.class \
fib/FibJavaSeq.class \
fib/fib_manticore_ptuple \
fib/fib_maple_par \
fib/fib_ocaml_domainslib \
nqueen/nqueen_c_myth \
nqueen/nqueen_c_pthread \
nqueen/nqueen_c_seq \
nqueen/nqueen_smlsharp_myth \
nqueen/nqueen_smlsharp_pthread \
nqueen/nqueen_smlsharp_seq \
nqueen/nqueen_ghc_par \
nqueen/nqueen_go_ref \
nqueen/nqueen_go_value \
nqueen/NqueenJavaForkJoin.class \
nqueen/NqueenJavaSeq.class \
nqueen/nqueen_manticore_ptuple \
nqueen/nqueen_maple_par \
nqueen/nqueen_ocaml_domainslib \
mandelbrot/mandelbrot_c_myth \
mandelbrot/mandelbrot_c_pthread \
mandelbrot/mandelbrot_c_seq \
mandelbrot/mandelbrot_smlsharp_myth \
mandelbrot/mandelbrot_smlsharp_pthread \
mandelbrot/mandelbrot_smlsharp_seq \
mandelbrot/mandelbrot_ghc_par \
mandelbrot/mandelbrot_ghc_forkIO \
mandelbrot/mandelbrot_go_value \
mandelbrot/MandelbrotJavaForkJoin.class \
mandelbrot/MandelbrotJavaSeq.class \
mandelbrot/mandelbrot_manticore_ptuple \
mandelbrot/mandelbrot_maple_par \
mandelbrot/mandelbrot_ocaml_domainslib \
cilksort/cilksort_c_myth \
cilksort/cilksort_c_pthread \
cilksort/cilksort_c_seq \
cilksort/cilksort_smlsharp_myth \
cilksort/cilksort_smlsharp_pthread \
cilksort/cilksort_smlsharp_seq \
cilksort/cilksort_manticore_ptuple \
cilksort/cilksort_maple_par \
cilksort/cilksort_ghc_par \
cilksort/cilksort_ghc_forkIO \
cilksort/cilksort_go_value \
cilksort/CilksortJavaForkJoin.class \
cilksort/CilksortJavaSeq.class \
cilksort/cilksort_ocaml_domainslib

clean:
	rm -f _thread/thread_c_myth.o
	rm -f _thread/thread_c_pthread.o
	rm -f _thread/thread_c_seq.o
	rm -f _thread/thread_smlsharp_myth.o
	rm -f _thread/thread_smlsharp_pthread.o
	rm -f _thread/thread_smlsharp_seq.o
	rm -f fib/fib_c_thread.o
	rm -f fib/fib_c_myth
	rm -f fib/fib_c_pthread
	rm -f fib/fib_c_seq
	rm -f fib/fib_smlsharp_thread.o
	rm -f fib/fib_smlsharp_myth
	rm -f fib/fib_smlsharp_pthread
	rm -f fib/fib_smlsharp_seq
	rm -f fib/fib_ghc_par.hi
	rm -f fib/fib_ghc_par.o
	rm -f fib/fib_ghc_par
	rm -f fib/fib_go_value
	rm -f fib/FibJavaForkJoin.class
	rm -f fib/FibJavaSeq.class
	rm -f fib/fib_manticore_ptuple.s
	rm -f fib/fib_manticore_ptuple
	rm -f fib/fib_maple_par
	rm -f fib/fib_ocaml_domainslib
	rm -f fib/fib_ocaml_domainslib.cmi
	rm -f fib/fib_ocaml_domainslib.cmx
	rm -f fib/fib_ocaml_domainslib.o
	rm -f nqueen/nqueen_c_thread.o
	rm -f nqueen/nqueen_c_myth
	rm -f nqueen/nqueen_c_pthread
	rm -f nqueen/nqueen_c_seq
	rm -f nqueen/nqueen_smlsharp_thread.o
	rm -f nqueen/nqueen_smlsharp_myth
	rm -f nqueen/nqueen_smlsharp_pthread
	rm -f nqueen/nqueen_smlsharp_seq
	rm -f nqueen/nqueen_ghc_par.hi
	rm -f nqueen/nqueen_ghc_par.o
	rm -f nqueen/nqueen_ghc_par
	rm -f nqueen/nqueen_go_ref
	rm -f nqueen/nqueen_go_value
	rm -f nqueen/NqueenJavaForkJoin.class
	rm -f nqueen/NqueenJavaForkJoin\$$Board.class
	rm -f nqueen/NqueenJavaSeq.class
	rm -f nqueen/NqueenJavaSeq\$$Board.class
	rm -f nqueen/nqueen_manticore_ptuple.s
	rm -f nqueen/nqueen_manticore_ptuple
	rm -f nqueen/nqueen_maple_par
	rm -f nqueen/nqueen_ocaml_domainslib
	rm -f nqueen/nqueen_ocaml_domainslib.cmi
	rm -f nqueen/nqueen_ocaml_domainslib.cmx
	rm -f nqueen/nqueen_ocaml_domainslib.o
	rm -f mandelbrot/mandelbrot_c_thread.o
	rm -f mandelbrot/mandelbrot_c_myth
	rm -f mandelbrot/mandelbrot_c_pthread
	rm -f mandelbrot/mandelbrot_c_seq
	rm -f mandelbrot/mandelbrot_smlsharp_thread.o
	rm -f mandelbrot/mandelbrot_smlsharp_myth
	rm -f mandelbrot/mandelbrot_smlsharp_pthread
	rm -f mandelbrot/mandelbrot_smlsharp_seq
	rm -f mandelbrot/mandelbrot_ghc_par.hi
	rm -f mandelbrot/mandelbrot_ghc_par.o
	rm -f mandelbrot/mandelbrot_ghc_par
	rm -f mandelbrot/mandelbrot_ghc_forkIO.hi
	rm -f mandelbrot/mandelbrot_ghc_forkIO.o
	rm -f mandelbrot/mandelbrot_ghc_forkIO
	rm -f mandelbrot/mandelbrot_go_value
	rm -f mandelbrot/mandelbrot_manticore_ptuple.s
	rm -f mandelbrot/mandelbrot_manticore_ptuple
	rm -f mandelbrot/mandelbrot_maple_par
	rm -f mandelbrot/MandelbrotJavaForkJoin.class
	rm -f mandelbrot/MandelbrotJavaSeq.class
	rm -f mandelbrot/mandelbrot_ocaml_domainslib
	rm -f mandelbrot/mandelbrot_ocaml_domainslib.cmi
	rm -f mandelbrot/mandelbrot_ocaml_domainslib.cmx
	rm -f mandelbrot/mandelbrot_ocaml_domainslib.o
	rm -f cilksort/cilksort_c_thread.o
	rm -f cilksort/cilksort_c_myth
	rm -f cilksort/cilksort_c_pthread
	rm -f cilksort/cilksort_c_seq
	rm -f cilksort/cilksort_smlsharp_thread.o
	rm -f cilksort/cilksort_smlsharp_myth
	rm -f cilksort/cilksort_smlsharp_pthread
	rm -f cilksort/cilksort_smlsharp_seq
	rm -f cilksort/cilksort_manticore_ptuple.s
	rm -f cilksort/cilksort_manticore_ptuple
	rm -f cilksort/cilksort_maple_par
	rm -f cilksort/cilksort_ghc_par.hi
	rm -f cilksort/cilksort_ghc_par.o
	rm -f cilksort/cilksort_ghc_par
	rm -f cilksort/cilksort_ghc_forkIO.hi
	rm -f cilksort/cilksort_ghc_forkIO.o
	rm -f cilksort/cilksort_ghc_forkIO
	rm -f cilksort/cilksort_go_value
	rm -f cilksort/CilksortJavaForkJoin.class
	rm -f cilksort/CilksortJavaForkJoin\$$Merge.class
	rm -f cilksort/CilksortJavaForkJoin\$$SortMerge.class
	rm -f cilksort/CilksortJavaSeq.class
	rm -f cilksort/cilksort_ocaml_domainslib
	rm -f cilksort/cilksort_ocaml_domainslib.cmi
	rm -f cilksort/cilksort_ocaml_domainslib.cmx
	rm -f cilksort/cilksort_ocaml_domainslib.o

bench: all bench.sh
	sh bench.sh

_thread/thread_c_myth.o: _thread/thread_c_myth.c _thread/thread_c.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ _thread/thread_c_myth.c
_thread/thread_c_pthread.o: _thread/thread_c_pthread.c _thread/thread_c.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ _thread/thread_c_pthread.c
_thread/thread_c_seq.o: _thread/thread_c_seq.c _thread/thread_c.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ _thread/thread_c_seq.c
_thread/thread_smlsharp_myth.o: _thread/thread_smlsharp_myth.sml _thread/thread_smlsharp.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ _thread/thread_smlsharp_myth.sml
_thread/thread_smlsharp_pthread.o: _thread/thread_smlsharp_pthread.sml _thread/thread_smlsharp.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ _thread/thread_smlsharp_pthread.sml
_thread/thread_smlsharp_seq.o: _thread/thread_smlsharp_seq.sml _thread/thread_smlsharp.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ _thread/thread_smlsharp_seq.sml

fib/fib_c_thread.o: fib/fib_c_thread.c _thread/thread_c.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ fib/fib_c_thread.c
fib/fib_c_myth: _thread/thread_c_myth.o fib/fib_c_thread.o
	$(CC) $(LDFLAGS) -o $@ fib/fib_c_thread.o _thread/thread_c_myth.o -lmyth
fib/fib_c_pthread: _thread/thread_c_pthread.o fib/fib_c_thread.o
	$(CC) $(LDFLAGS) -o $@ fib/fib_c_thread.o _thread/thread_c_pthread.o -pthread
fib/fib_c_seq: _thread/thread_c_seq.o fib/fib_c_thread.o
	$(CC) $(LDFLAGS) -o $@ fib/fib_c_thread.o _thread/thread_c_seq.o
fib/fib_smlsharp_thread.o: fib/fib_smlsharp_thread.sml fib/fib_smlsharp_thread.smi _thread/thread_smlsharp.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ fib/fib_smlsharp_thread.sml
fib/fib_smlsharp_myth: fib/fib_smlsharp_thread.smi _thread/thread_smlsharp.smi _thread/thread_smlsharp_myth.o fib/fib_smlsharp_thread.o smlsharp_myth.filemap
	$(SMLSHARP) $(LDFLAGS) -filemap=smlsharp_myth.filemap -o $@ fib/fib_smlsharp_thread.smi -lmyth
fib/fib_smlsharp_pthread: fib/fib_smlsharp_thread.smi _thread/thread_smlsharp.smi _thread/thread_smlsharp_pthread.o fib/fib_smlsharp_thread.o smlsharp_pthread.filemap
	$(SMLSHARP) $(LDFLAGS) -filemap=smlsharp_pthread.filemap -o $@ fib/fib_smlsharp_thread.smi
fib/fib_smlsharp_seq: fib/fib_smlsharp_thread.smi _thread/thread_smlsharp.smi _thread/thread_smlsharp_seq.o fib/fib_smlsharp_thread.o smlsharp_seq.filemap
	$(SMLSHARP) $(LDFLAGS) -filemap=smlsharp_seq.filemap -o $@ fib/fib_smlsharp_thread.smi
fib/fib_ghc_par: fib/fib_ghc_par.hs
	$(GHC) -threaded $(GHCFLAGS) fib/fib_ghc_par.hs
fib/fib_go_value: fib/fib_go_value.go
	$(GO) build -o $@ fib/fib_go_value.go
fib/FibJavaForkJoin.class: fib/fib_java_forkjoin.java
	$(JAVAC) fib/fib_java_forkjoin.java
fib/FibJavaSeq.class: fib/fib_java_seq.java
	$(JAVAC) fib/fib_java_seq.java
fib/fib_manticore_ptuple: fib/fib_manticore_ptuple.pml
	$(PMLC) -o $@ fib/fib_manticore_ptuple.pml
fib/fib_maple_par: fib/fib_maple_par.sml fib/fib_maple_par.mlb
	$(MPL) fib/fib_maple_par.mlb
fib/fib_ocaml_domainslib: fib/fib_ocaml_domainslib.ml
	$(OCAMLFIND) ocamlopt -linkpkg -package domainslib,unix -o $@ -O2 fib/fib_ocaml_domainslib.ml

nqueen/nqueen_c_thread.o: nqueen/nqueen_c_thread.c _thread/thread_c.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ nqueen/nqueen_c_thread.c
nqueen/nqueen_c_myth: _thread/thread_c_myth.o nqueen/nqueen_c_thread.o
	$(CC) $(LDFLAGS) -o $@ nqueen/nqueen_c_thread.o _thread/thread_c_myth.o -lmyth
nqueen/nqueen_c_pthread: _thread/thread_c_pthread.o nqueen/nqueen_c_thread.o
	$(CC) $(LDFLAGS) -o $@ nqueen/nqueen_c_thread.o _thread/thread_c_pthread.o -pthread
nqueen/nqueen_c_seq: _thread/thread_c_seq.o nqueen/nqueen_c_thread.o
	$(CC) $(LDFLAGS) -o $@ nqueen/nqueen_c_thread.o _thread/thread_c_seq.o
nqueen/nqueen_smlsharp_thread.o: nqueen/nqueen_smlsharp_thread.sml nqueen/nqueen_smlsharp_thread.smi _thread/thread_smlsharp.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ nqueen/nqueen_smlsharp_thread.sml
nqueen/nqueen_smlsharp_myth: nqueen/nqueen_smlsharp_thread.smi _thread/thread_smlsharp.smi _thread/thread_smlsharp_myth.o nqueen/nqueen_smlsharp_thread.o smlsharp_myth.filemap
	$(SMLSHARP) $(LDFLAGS) -filemap=smlsharp_myth.filemap -o $@ nqueen/nqueen_smlsharp_thread.smi -lmyth
nqueen/nqueen_smlsharp_pthread: nqueen/nqueen_smlsharp_thread.smi _thread/thread_smlsharp.smi _thread/thread_smlsharp_pthread.o nqueen/nqueen_smlsharp_thread.o smlsharp_pthread.filemap
	$(SMLSHARP) $(LDFLAGS) -filemap=smlsharp_pthread.filemap -o $@ nqueen/nqueen_smlsharp_thread.smi
nqueen/nqueen_smlsharp_seq: nqueen/nqueen_smlsharp_thread.smi _thread/thread_smlsharp.smi _thread/thread_smlsharp_seq.o nqueen/nqueen_smlsharp_thread.o smlsharp_seq.filemap
	$(SMLSHARP) $(LDFLAGS) -filemap=smlsharp_seq.filemap -o $@ nqueen/nqueen_smlsharp_thread.smi
nqueen/nqueen_ghc_par: nqueen/nqueen_ghc_par.hs
	$(GHC) -threaded $(GHCFLAGS) nqueen/nqueen_ghc_par.hs
nqueen/nqueen_go_value: nqueen/nqueen_go_value.go
	$(GO) build -o $@ nqueen/nqueen_go_value.go
nqueen/nqueen_go_ref: nqueen/nqueen_go_ref.go
	$(GO) build -o $@ nqueen/nqueen_go_ref.go
nqueen/NqueenJavaForkJoin.class: nqueen/nqueen_java_forkjoin.java
	$(JAVAC) nqueen/nqueen_java_forkjoin.java
nqueen/NqueenJavaSeq.class: nqueen/nqueen_java_seq.java
	$(JAVAC) nqueen/nqueen_java_seq.java
nqueen/nqueen_manticore_ptuple: nqueen/nqueen_manticore_ptuple.pml
	$(PMLC) -o $@ nqueen/nqueen_manticore_ptuple.pml
nqueen/nqueen_maple_par: nqueen/nqueen_maple_par.sml nqueen/nqueen_maple_par.mlb
	$(MPL) nqueen/nqueen_maple_par.mlb
nqueen/nqueen_ocaml_domainslib: nqueen/nqueen_ocaml_domainslib.ml
	$(OCAMLFIND) ocamlopt -linkpkg -package domainslib,unix -o $@ -O2 nqueen/nqueen_ocaml_domainslib.ml

mandelbrot/mandelbrot_c_thread.o: mandelbrot/mandelbrot_c_thread.c _thread/thread_c.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ mandelbrot/mandelbrot_c_thread.c
mandelbrot/mandelbrot_c_myth: _thread/thread_c_myth.o mandelbrot/mandelbrot_c_thread.o
	$(CC) $(LDFLAGS) -o $@ mandelbrot/mandelbrot_c_thread.o _thread/thread_c_myth.o -lmyth
mandelbrot/mandelbrot_c_pthread: _thread/thread_c_pthread.o mandelbrot/mandelbrot_c_thread.o
	$(CC) $(LDFLAGS) -o $@ mandelbrot/mandelbrot_c_thread.o _thread/thread_c_pthread.o -pthread
mandelbrot/mandelbrot_c_seq: _thread/thread_c_seq.o mandelbrot/mandelbrot_c_thread.o
	$(CC) $(LDFLAGS) -o $@ mandelbrot/mandelbrot_c_thread.o _thread/thread_c_seq.o

=== sample/glut/Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 SMLSHARP = smlsharp
-LIBS = -Wl,-framework,OpenGL -Wl,-framework,GLUT  # for Mac OS X
+#LIBS = -Wl,-framework,OpenGL -Wl,-framework,GLUT  # for Mac OS X
 #LIBS = -L/usr/X11R6/lib -lgl -lglu -lglut
+LIBS = -L/usr/lib -lGL -lGLU -lglut
 
 cube: cube.smi cube.o libglut.o
 	$(SMLSHARP) -o $@ cube.smi $(LIBS)

=== sample/pthread_sieve/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-SMLSHARP = smlsharp
+SMLSHARP = ../../src/compiler/smlsharp -B../../src
 
 pthread_sieve: load.smi pthread.o mvar.o sieve.o load.o
 	$(SMLSHARP) -o $@ load.smi $(LIBS)

=== sample/stdio/Makefile ===
SMLSHARP = smlsharp

stdio: stdio.sml
	$(SMLSHARP) -o $@ stdio.sml

clean:
	-rm -f stdio

=== src/smlunit/Makefile ===
SMLSHARP_ENV = SMLSHARP_HEAPSIZE=128M:1G
SMLSHARP = smlsharp
SMLFLAGS = -O2

all: src/main/SMLUnit.o src/main/TextUITestRunner.o src/main/Test.o \
 src/main/Assert.o

src/main/Assert.o: src/main/Assert.sml src/main/Assert.smi src/main/ASSERT.sig \
 src/main/Assert.smi
src/main/SMLUnit.o: src/main/SMLUnit.sml src/main/SMLUnit.smi \
 src/main/ASSERT.sig src/main/Assert.smi src/main/TEST.sig src/main/Test.smi \
 src/main/TESTRUNNER.sig src/main/TextUITestRunner.smi src/main/SMLUNIT.sig \
 src/main/SMLUnit.smi
src/main/Test.o: src/main/Test.sml src/main/Test.smi src/main/TEST.sig \
 src/main/Test.smi
src/main/TextUITestRunner.o: src/main/TextUITestRunner.sml \
 src/main/TextUITestRunner.smi src/main/ASSERT.sig src/main/Assert.smi \
 src/main/TEST.sig src/main/Test.smi src/main/TESTRUNNER.sig \
 src/main/TextUITestRunner.smi

.sml.o:
	$(SMLSHARP_ENV) $(SMLSHARP) $(SMLFLAGS) -c -o $@ $<

clean: PHONY
	rm -f src/main/SMLUnit.o src/main/TextUITestRunner.o src/main/Test.o \
 src/main/Assert.o

PHONY: # force to rebuild

.SUFFIXES: .sml

=== src/smlunit/src/test/Makefile ===
SMLSHARP_ENV = SMLSHARP_HEAPSIZE=128M:1G
SMLSHARP = smll
SMLFLAGS = -O2
ALLOBJECTS = Main.o TestMain.o TestTextUITestRunner.o TestTest.o TestAssert.o

testExec: $(ALLOBJECTS)
	$(SMLSHARP_ENV) $(SMLSHARP) $(SMLFLAGS) -o testExec Main.smi

Main.o: Main.sml Main.smi TestAssert.smi TestTest.smi TestTextUITestRunner.smi \
 TestMain.smi Main.smi
TestAssert.o: TestAssert.sml TestAssert.smi TestAssert.smi
TestMain.o: TestMain.sml TestMain.smi TestAssert.smi TestTest.smi \
 TestTextUITestRunner.smi TestMain.smi
TestTest.o: TestTest.sml TestTest.smi TestTest.smi
TestTextUITestRunner.o: TestTextUITestRunner.sml TestTextUITestRunner.smi \
 TestTextUITestRunner.smi

.sml.o:
	$(SMLSHARP_ENV) $(SMLSHARP) $(SMLFLAGS) -c -o $@ $<

.SUFFIXES: .sml

clean: PHONY
	rm -f $(ALLOBJECTS) testExec

PHONY:

=== debian/changelog ===
smlsharp (4.0.0+git20211227.5af5945b-1) unstable; urgency=medium

  * Snapshot, taken from the master (20220106). (Closes: #1002084)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 06 Jan 2022 09:26:36 +0900

=== debian/control ===
Source: smlsharp
Section: devel
Priority: optional
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper-compat (= 13),
               libgmp-dev,
               llvm-dev,
               libmassivethreads-dev
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://smlsharp.github.io
Vcs-Git: https://salsa.debian.org/debian/smlsharp.git
Vcs-Browser: https://salsa.debian.org/debian/smlsharp

Package: smlsharp
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Standard ML compiler with practical extensions
 SML# is a variant of Standard ML programming
 language with several practical extentions,
 including seamless interoperability with C,
 integration with SQL, and separate compilation.
